'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = buildScalar;

var _type = require('graphql/type');

var _buildASTSchema = require('graphql/utilities/buildASTSchema');

function buildScalar(scalarAST) {
  var config = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var _ref = config instanceof _type.GraphQLScalarType ? config._scalarConfig : config;

  var serialize = _ref.serialize;
  var parseValue = _ref.parseValue;
  var parseLiteral = _ref.parseLiteral;

  var scalarTypeConfig = { name: scalarAST.name.value, serialize: serialize, parseValue: parseValue, parseLiteral: parseLiteral };
  var description = (0, _buildASTSchema.getDescription)(scalarAST);
  if (description) scalarTypeConfig.description = description;
  return new _type.GraphQLScalarType(scalarTypeConfig);
}